#include <stdio.h>   /* Standard input/output definitions */
#include <string.h>  /* String function definitions */
#include <unistd.h>  /* UNIX standard function definitions */
#include <fcntl.h>   /* File control definitions */
#include <errno.h>   /* Error number definitions */
#include <termios.h> /* POSIX terminal control definitions */

/*
 * 'open_port()' - Open serial port 1.
 *
 * Returns the file descriptor on success or -1 on error.
 */

int open_port(void)
{
  int fd; /* File descriptor for the port */
  struct termios options;
  
  fd = open("/dev/ttyS0", O_RDWR | O_NOCTTY);
  
  
  if (fd == -1)
    {
      /*
       * Could not open the port.
       */
      
      perror("open_port: Unable to open /dev/ttyS0 - ");
    }
  else
    fcntl(fd, F_SETFL, 0);
  
  
  /*
   * Get the current options for the port...
   */
  
  tcgetattr(fd, &options);
  
  /*
   * Set the baud rates to 9600...
   */
  //options.c_cflag = CS8;
  cfsetispeed(&options, B9600);
  cfsetospeed(&options, B9600);
  
  /*
   * Enable the receiver and set local mode...
   */
  
  options.c_cflag |= (CLOCAL | CREAD | CS8);
  options.c_cflag &= ~PARENB;
  options.c_cflag &= ~CSTOPB;
  options.c_cflag &= ~CSIZE;
  options.c_cflag |= CS8;
  //options.c_cflag &= ~CNEW_RTSCTS;
  options.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG);

  /*
   * Set the new options for the port...
   */
  
  tcsetattr(fd, TCSANOW, &options);
  
  
  return (fd);
}

unsigned char get_byte(int fd)
{
  
  unsigned char c, buffer[10];
  int i;
  long timeout;
  
  timeout = 0;
  i = read(fd,buffer,1);
  
  while((i==0)&(timeout<10000000))
    {
      i=read(fd,buffer,1);
      timeout++;
    }
  if (timeout>(10000000-1))
    {
      return -1;
    }
  else
    {
      c=buffer[0];
      return c;
    }
  /*
  if(i == -1)
    return -1;
  
  c=buffer[0];
  return c;
  */
}

void put_bytes(int fd,unsigned char *buf, int len)
{
  int r;
  //char buf[256];
    
  //buf= c;
  
  if(write(fd,buf,len) != len)
    printf("fehler beim senden \n", r);
  
}
